Runs - Create
POST https://vstmr.dev.azure.com/{organization}/{project}/_apis/testresults/runs?api-version=7.1-preview.1
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
organization
|
path | True |
string |
The name of the Azure DevOps organization. |
|
project
|
path | True |
string |
Project ID or project name |
|
api-version
|
query | True |
string |
Version of the API to use. This should be set to '7.1-preview.1' to use this version of the api. |
Request Body
| Name | Type | Description |
|---|---|---|
| automated |
boolean |
true if test run is automated, false otherwise. By default it will be false. |
| build |
An abstracted reference to the build that it belongs. |
|
| buildDropLocation |
string |
Drop location of the build used for test run. |
| buildFlavor |
string |
Flavor of the build used for test run. (E.g: Release, Debug) |
| buildPlatform |
string |
Platform of the build used for test run. (E.g.: x86, amd64) |
| buildReference |
BuildReference of the test run. |
|
| comment |
string |
Comments entered by those analyzing the run. |
| completeDate |
string |
Completed date time of the run. |
| configurationIds |
integer[] (int32) |
IDs of the test configurations associated with the run. |
| controller |
string |
Name of the test controller used for automated run. |
| customTestFields |
Additional properties of test Run. |
|
| dtlAutEnvironment |
An abstracted reference to DtlAutEnvironment. |
|
| dtlTestEnvironment |
An abstracted reference to DtlTestEnvironment. |
|
| dueDate |
string |
Due date and time for test run. |
| environmentDetails |
This is a temporary class to provide the details for the test run environment. |
|
| errorMessage |
string |
Error message associated with the run. |
| filter |
Filter used for discovering the Run. |
|
| iteration |
string |
The iteration in which to create the run. Root iteration of the team project will be default |
| name |
string |
Name of the test run. |
| owner |
Display name of the owner of the run. |
|
| pipelineReference |
Reference of the pipeline to which this test run belongs. PipelineReference.PipelineId should be equal to RunCreateModel.Build.Id |
|
| plan |
An abstracted reference to the plan that it belongs. |
|
| pointIds |
integer[] (int32) |
IDs of the test points to use in the run. |
| releaseEnvironmentUri |
string |
URI of release environment associated with the run. |
| releaseReference |
Reference to release associated with test run. |
|
| releaseUri |
string |
URI of release associated with the run. |
| runSummary |
Run summary for run Type = NoConfigRun. |
|
| runTimeout |
string (TimeSpan) |
Timespan till the run times out. |
| sourceWorkflow |
string |
SourceWorkFlow(CI/CD) of the test run. |
| startDate |
string |
Start date time of the run. |
| state |
string |
The state of the run. Type TestRunState Valid states - NotStarted, InProgress, Waiting |
| tags |
Test |
Tags to attach with the test run, maximum of 5 tags can be added to run. |
| testConfigurationsMapping |
string |
TestConfigurationMapping of the test run. |
| testEnvironmentId |
string |
ID of the test environment associated with the run. |
| testSettings |
An abstracted reference to the test settings resource. |
|
| type |
string |
Type of the run(RunType) Valid Values : (Unspecified, Normal, Blocking, Web, MtrRunInitiatedFromWeb, RunWithDtlEnv, NoConfigRun) |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
successful operation |
Security
oauth2
Type:
oauth2
Flow:
accessCode
Authorization URL:
https://app.vssps.visualstudio.com/oauth2/authorize&response_type=Assertion
Token URL:
https://app.vssps.visualstudio.com/oauth2/token?client_assertion_type=urn:ietf:params:oauth:client-assertion-type:jwt-bearer&grant_type=urn:ietf:params:oauth:grant-type:jwt-bearer
Scopes
| Name | Description |
|---|---|
| vso.test_write | Grants the ability to read, create, and update test plans, cases, results and other test management related artifacts. |
Definitions
| Name | Description |
|---|---|
|
Build |
BuildConfiguration Details. |
|
Custom |
A custom field information. Allowed Key : Value pairs - ( AttemptId: int value, IsTestResultFlaky: bool) |
|
Dtl |
This is a temporary class to provide the details for the test run environment. |
|
Identity |
|
|
Job |
Job in pipeline. This is related to matrixing in YAML. |
|
Phase |
Phase in pipeline |
|
Pipeline |
Pipeline reference |
|
Reference |
|
|
Release |
Reference to a release. |
|
Result |
ResultMetadata for the given outcome/count. |
|
Run |
Test run create details. |
|
Run |
This class is used to provide the filters used for discovery |
|
Run |
Test run statistics per outcome. |
|
Run |
Run summary for each output type of test. |
|
Shallow |
An abstracted reference to some other resource. This class is used to provide the build data contracts with a uniform way to reference other resources in a way that provides easy traversal through links. |
|
Stage |
Stage in pipeline |
|
Test |
Test environment Detail. |
|
Test |
|
|
Test |
Test Resolution State Details. |
|
Test |
Test run details. |
|
Test |
The types of sub states for test run. |
|
Test |
Tag attached to a run or result. |
BuildConfiguration
BuildConfiguration Details.
| Name | Type | Description |
|---|---|---|
| branchName |
string |
Branch name for which build is generated. |
| buildDefinitionId |
integer (int32) |
BuildDefinitionId for build. |
| buildSystem |
string |
Build system. |
| creationDate |
string (date-time) |
Build Creation Date. |
| flavor |
string |
Build flavor (eg Build/Release). |
| id |
integer (int32) |
BuildConfiguration Id. |
| number |
string |
Build Number. |
| platform |
string |
BuildConfiguration Platform. |
| project |
Project associated with this BuildConfiguration. |
|
| repositoryGuid |
string |
Repository Guid for the Build. |
| repositoryType |
string |
Repository Type (eg. TFSGit). |
| sourceVersion |
string |
Source Version(/first commit) for the build was triggered. |
| targetBranchName |
string |
Target BranchName. |
| uri |
string |
Build Uri. |
CustomTestField
A custom field information. Allowed Key : Value pairs - ( AttemptId: int value, IsTestResultFlaky: bool)
| Name | Type | Description |
|---|---|---|
| fieldName |
string |
Field Name. |
| value |
object |
Field value. |
DtlEnvironmentDetails
This is a temporary class to provide the details for the test run environment.
| Name | Type | Description |
|---|---|---|
| csmContent |
string |
|
| csmParameters |
string |
|
| subscriptionName |
string |
IdentityRef
| Name | Type | Description |
|---|---|---|
| _links | ||
| descriptor |
string |
|
| directoryAlias |
string |
|
| displayName |
string |
|
| id |
string |
|
| imageUrl |
string |
|
| inactive |
boolean |
|
| isAadIdentity |
boolean |
|
| isContainer |
boolean |
|
| isDeletedInOrigin |
boolean |
|
| profileUrl |
string |
|
| uniqueName |
string |
|
| url |
string |
JobReference
Job in pipeline. This is related to matrixing in YAML.
| Name | Type | Description |
|---|---|---|
| attempt |
integer (int32) |
Attempt number of the job |
| jobName |
string |
Matrixing in YAML generates copies of a job with different inputs in matrix. JobName is the name of those input. Maximum supported length for name is 256 character. |
PhaseReference
Phase in pipeline
| Name | Type | Description |
|---|---|---|
| attempt |
integer (int32) |
Attempt number of the phase |
| phaseName |
string |
Name of the phase. Maximum supported length for name is 256 character. |
PipelineReference
Pipeline reference
| Name | Type | Description |
|---|---|---|
| jobReference |
Reference of the job |
|
| phaseReference |
Reference of the phase. |
|
| pipelineId |
integer (int32) |
Reference of the pipeline with which this pipeline instance is related. |
| stageReference |
Reference of the stage. |
ReferenceLinks
| Name | Type | Description |
|---|---|---|
| links |
object |
ReleaseReference
Reference to a release.
| Name | Type | Description |
|---|---|---|
| attempt |
integer (int32) |
Number of Release Attempt. |
| creationDate |
string (date-time) |
Release Creation Date(UTC). |
| definitionId |
integer (int32) |
Release definition ID. |
| environmentCreationDate |
string (date-time) |
Environment creation Date(UTC). |
| environmentDefinitionId |
integer (int32) |
Release environment definition ID. |
| environmentDefinitionName |
string |
Release environment definition name. |
| environmentId |
integer (int32) |
Release environment ID. |
| environmentName |
string |
Release environment name. |
| id |
integer (int32) |
Release ID. |
| name |
string |
Release name. |
ResultMetadata
ResultMetadata for the given outcome/count.
| Value | Description |
|---|---|
| rerun |
Rerun metadata |
| flaky |
Flaky metadata |
RunCreateModel
Test run create details.
| Name | Type | Description |
|---|---|---|
| automated |
boolean |
true if test run is automated, false otherwise. By default it will be false. |
| build |
An abstracted reference to the build that it belongs. |
|
| buildDropLocation |
string |
Drop location of the build used for test run. |
| buildFlavor |
string |
Flavor of the build used for test run. (E.g: Release, Debug) |
| buildPlatform |
string |
Platform of the build used for test run. (E.g.: x86, amd64) |
| buildReference |
BuildReference of the test run. |
|
| comment |
string |
Comments entered by those analyzing the run. |
| completeDate |
string |
Completed date time of the run. |
| configurationIds |
integer[] (int32) |
IDs of the test configurations associated with the run. |
| controller |
string |
Name of the test controller used for automated run. |
| customTestFields |
Additional properties of test Run. |
|
| dtlAutEnvironment |
An abstracted reference to DtlAutEnvironment. |
|
| dtlTestEnvironment |
An abstracted reference to DtlTestEnvironment. |
|
| dueDate |
string |
Due date and time for test run. |
| environmentDetails |
This is a temporary class to provide the details for the test run environment. |
|
| errorMessage |
string |
Error message associated with the run. |
| filter |
Filter used for discovering the Run. |
|
| iteration |
string |
The iteration in which to create the run. Root iteration of the team project will be default |
| name |
string |
Name of the test run. |
| owner |
Display name of the owner of the run. |
|
| pipelineReference |
Reference of the pipeline to which this test run belongs. PipelineReference.PipelineId should be equal to RunCreateModel.Build.Id |
|
| plan |
An abstracted reference to the plan that it belongs. |
|
| pointIds |
integer[] (int32) |
IDs of the test points to use in the run. |
| releaseEnvironmentUri |
string |
URI of release environment associated with the run. |
| releaseReference |
Reference to release associated with test run. |
|
| releaseUri |
string |
URI of release associated with the run. |
| runSummary |
Run summary for run Type = NoConfigRun. |
|
| runTimeout |
string (TimeSpan) |
Timespan till the run times out. |
| sourceWorkflow |
string |
SourceWorkFlow(CI/CD) of the test run. |
| startDate |
string |
Start date time of the run. |
| state |
string |
The state of the run. Type TestRunState Valid states - NotStarted, InProgress, Waiting |
| tags |
Test |
Tags to attach with the test run, maximum of 5 tags can be added to run. |
| testConfigurationsMapping |
string |
TestConfigurationMapping of the test run. |
| testEnvironmentId |
string |
ID of the test environment associated with the run. |
| testSettings |
An abstracted reference to the test settings resource. |
|
| type |
string |
Type of the run(RunType) Valid Values : (Unspecified, Normal, Blocking, Web, MtrRunInitiatedFromWeb, RunWithDtlEnv, NoConfigRun) |
RunFilter
This class is used to provide the filters used for discovery
| Name | Type | Description |
|---|---|---|
| sourceFilter |
string |
filter for the test case sources (test containers) |
| testCaseFilter |
string |
filter for the test cases |
RunStatistic
Test run statistics per outcome.
| Name | Type | Description |
|---|---|---|
| count |
integer (int32) |
Test result count fo the given outcome. |
| outcome |
string |
Test result outcome |
| resolutionState |
Test run Resolution State. |
|
| resultMetadata |
ResultMetadata for the given outcome/count. |
|
| state |
string |
State of the test run |
RunSummaryModel
Run summary for each output type of test.
| Name | Type | Description |
|---|---|---|
| duration |
integer (int64) |
Total time taken in milliseconds. |
| resultCount |
integer (int32) |
Number of results for Outcome TestOutcome |
| testOutcome |
Summary is based on outcome |
ShallowReference
An abstracted reference to some other resource. This class is used to provide the build data contracts with a uniform way to reference other resources in a way that provides easy traversal through links.
| Name | Type | Description |
|---|---|---|
| id |
string |
ID of the resource |
| name |
string |
Name of the linked resource (definition name, controller name, etc.) |
| url |
string |
Full http link to the resource |
StageReference
Stage in pipeline
| Name | Type | Description |
|---|---|---|
| attempt |
integer (int32) |
Attempt number of stage |
| stageName |
string |
Name of the stage. Maximum supported length for name is 256 character. |
TestEnvironment
Test environment Detail.
| Name | Type | Description |
|---|---|---|
| environmentId |
string (uuid) |
Test Environment Id. |
| environmentName |
string |
Test Environment Name. |
TestOutcome
| Value | Description |
|---|---|
| unspecified |
Only used during an update to preserve the existing value. |
| none |
Test has not been completed, or the test type does not report pass/failure. |
| passed |
Test was executed w/o any issues. |
| failed |
Test was executed, but there were issues. Issues may involve exceptions or failed assertions. |
| inconclusive |
Test has completed, but we can't say if it passed or failed. May be used for aborted tests... |
| timeout |
The test timed out |
| aborted |
Test was aborted. This was not caused by a user gesture, but rather by a framework decision. |
| blocked |
Test had it chance for been executed but was not, as ITestElement.IsRunnable == false. |
| notExecuted |
Test was not executed. This was caused by a user gesture - e.g. user hit stop button. |
| warning |
To be used by Run level results. This is not a failure. |
| error |
There was a system error while we were trying to execute a test. |
| notApplicable |
Test is Not Applicable for execution. |
| paused |
Test is paused. |
| inProgress |
Test is currently executing. Added this for TCM charts |
| notImpacted |
Test is not impacted. Added fot TIA. |
TestResolutionState
Test Resolution State Details.
| Name | Type | Description |
|---|---|---|
| id |
integer (int32) |
Test Resolution state Id. |
| name |
string |
Test Resolution State Name. |
| project |
An abstracted reference to some other resource. This class is used to provide the build data contracts with a uniform way to reference other resources in a way that provides easy traversal through links. |
TestRun
Test run details.
| Name | Type | Description |
|---|---|---|
| build |
Build associated with this test run. |
|
| buildConfiguration |
Build configuration details associated with this test run. |
|
| comment |
string |
Comments entered by those analyzing the run. |
| completedDate |
string (date-time) |
Completed date time of the run. |
| controller |
string |
Test Run Controller. |
| createdDate |
string (date-time) |
Test Run CreatedDate. |
| customFields |
List of Custom Fields for TestRun. |
|
| dropLocation |
string |
Drop Location for the test Run. |
| dtlAutEnvironment |
An abstracted reference to some other resource. This class is used to provide the build data contracts with a uniform way to reference other resources in a way that provides easy traversal through links. |
|
| dtlEnvironment |
An abstracted reference to some other resource. This class is used to provide the build data contracts with a uniform way to reference other resources in a way that provides easy traversal through links. |
|
| dtlEnvironmentCreationDetails |
This is a temporary class to provide the details for the test run environment. |
|
| dueDate |
string (date-time) |
Due date and time for test run. |
| errorMessage |
string |
Error message associated with the run. |
| filter |
This class is used to provide the filters used for discovery |
|
| id |
integer (int32) |
ID of the test run. |
| incompleteTests |
integer (int32) |
Number of Incomplete Tests. |
| isAutomated |
boolean |
true if test run is automated, false otherwise. |
| iteration |
string |
The iteration to which the run belongs. |
| lastUpdatedBy |
Team foundation ID of the last updated the test run. |
|
| lastUpdatedDate |
string (date-time) |
Last updated date and time |
| name |
string |
Name of the test run. |
| notApplicableTests |
integer (int32) |
Number of Not Applicable Tests. |
| owner |
Team Foundation ID of the owner of the runs. |
|
| passedTests |
integer (int32) |
Number of passed tests in the run |
| phase |
string |
Phase/State for the testRun. |
| pipelineReference |
Reference of the pipeline to which this test run belongs. |
|
| plan |
Test plan associated with this test run. |
|
| postProcessState |
string |
Post Process State. |
| project |
Project associated with this run. |
|
| release |
Release Reference for the Test Run. |
|
| releaseEnvironmentUri |
string |
Release Environment Uri for TestRun. |
| releaseUri |
string |
Release Uri for TestRun. |
| revision |
integer (int32) |
|
| runStatistics |
RunSummary by outcome. |
|
| startedDate |
string (date-time) |
Start date time of the run. |
| state |
string |
The state of the run. Type TestRunState Valid states - Unspecified ,NotStarted, InProgress, Completed, Waiting, Aborted, NeedsInvestigation |
| substate |
TestRun Substate. |
|
| tags |
Test |
Tags attached with this test run. |
| testEnvironment |
Test environment associated with the run. |
|
| testMessageLogId |
integer (int32) |
|
| testSettings |
An abstracted reference to some other resource. This class is used to provide the build data contracts with a uniform way to reference other resources in a way that provides easy traversal through links. |
|
| totalTests |
integer (int32) |
Total tests in the run |
| unanalyzedTests |
integer (int32) |
Number of failed tests in the run. |
| url |
string |
Url of the test run |
| webAccessUrl |
string |
Web Access Url for TestRun. |
TestRunSubstate
The types of sub states for test run.
| Value | Description |
|---|---|
| none |
Run with noState. |
| creatingEnvironment |
Run state while Creating Environment. |
| runningTests |
Run state while Running Tests. |
| canceledByUser |
Run state while Creating Environment. |
| abortedBySystem |
Run state when it is Aborted By the System. |
| timedOut |
Run state when run has timedOut. |
| pendingAnalysis |
Run state while Pending Analysis. |
| analyzed |
Run state after being Analysed. |
| cancellationInProgress |
Run state when cancellation is in Progress. |
TestTag
Tag attached to a run or result.
| Name | Type | Description |
|---|---|---|
| name |
string |
Name of the tag, alphanumeric value less than 30 chars |